;--------------------------------------------;
; Etch-A-Sketch for Doors CS 6+              ;
; With support for external shake sensor     ;
; Christopher "Kerm Martian" Mitchell 2010   ;
; http://www.cemetech.net                    ;
;--------------------------------------------;
.nolist
#include "dcs6.inc"
.list
mysaferam		.equ	saferam1
etch_x			.equ	mysaferam
etch_y			.equ	etch_x+1
IO_PORT_MASK 	.equ	%00000011
KBDROW_ARROWS	.equ	$fe
KBDROW_CLEAR	.equ	$fd
KBDROW_MODE		.equ	$bf
KBDBIT_UP		.equ	3
KBDBIT_DOWN		.equ	0
KBDBIT_LEFT		.equ	1
KBDBIT_RIGHT	.equ	2
KBDBIT_CLEAR	.equ	6
KBDBIT_MODE		.equ	6

	.org $9d95-2
	.db $BB,$6D				;asmprgm

	xor d
	ret
	jr Start
	.dw Description
	.db $05,00
	.dw Icon
	.dw 0000
Icon:
	.db $7f,$fe
	.db $bf,$fd
	.db $a0,$05
	.db $a0,$05
	.db $a0,$05
	.db $a0,$05
	.db $a0,$05
	.db $a0,$05
	.db $a0,$05
	.db $bf,$fd
	.db $80,$01
	.db $98,$19
	.db $bc,$3d
	.db $bc,$3d
	.db $98,$19
	.db $7f,$fe
Description:
	.db "Etch-a-Sketch DE 1.0",0

Start:
	di
	bcall(_cleargbuf)
	set textwrite,(iy+sgrflags)
	ld ix,Icon
	ld a,2
	ld l,46
	ld b,16
	ld c,2
	call ionLargeSprite
	ld hl,(46*256)+20
	ld (pencol),hl
	ld hl,Description
	bcall(_vputs)
	ld hl,(53*256)+20
	ld (pencol),hl
	ld hl,InfoTxt2
	bcall(_vputs)
	call ionFastCopy
	call Pause
	bcall(_cleargbuf)
	call ionFastCopy
	ld hl,(32*256)+48
	ld (etch_x),hl				;loads etch_x and etch_y
Loop:
	in a,(0)
	and IO_PORT_MASK
	sub IO_PORT_MASK
	jr z,LoopKeys
LoopClear:
	ld b,16
LoopClear1:
	push bc
		ld b,63
		call ionRandom
		ld e,0
		call iGetPixel
		xor $ff
		ld de,12
		ld b,64
LoopClearVertLine:
		ld c,(hl)
		and c
		ld (hl),c
		add hl,de
		djnz LoopClearVertLine
		ld b,95
		call ionRandom
		ld e,a
		xor a
		call iGetPixel
		ld b,12
		xor a
LoopClearHorizLine:
		ld (hl),a
		inc hl
		djnz LoopClearHorizLine
		call ionFastCopy
		pop bc
	djnz LoopClear1
LoopKeys:
	ld a,KBDROW_ARROWS
	out (1),a
	nop \ nop
	in a,(1)
	bit KBDBIT_LEFT,a
	call z,GoLeft
	bit KBDBIT_RIGHT,a
	call z,GoRight
	bit KBDBIT_UP,a
	call z,GoUp
	bit KBDBIT_DOWN,a
	call z,GoDown
	
	ld a,KBDROW_CLEAR
	out (1),a
	nop \ nop
	in a,(1)
	bit KBDBIT_CLEAR,a
	jr z,LoopClear

	ld a,KBDROW_MODE
	out (1),a
	nop \ nop
	in a,(1)
	bit KBDBIT_MODE,a
	jr z,Quit

	ld hl,(etch_x)			;h = y, l = x

	ld a,l
	ld e,h
	call ionGetPixel
	ld b,(hl)
	or b
	ld (hl),a
	call ionFastCopy
	jr Loop
	
Quit:
	res textwrite,(iy+sgrflags)
	ei
	ret

GoUp:
	push af
		ld a,(etch_y)
		or a
		jr z,GoDone
		dec a
GoDoneY:
		ld (etch_y),a
GoDone:
		pop af
	ret
GoDown:
	push af
		ld a,(etch_y)
		cp 63
		jr z,GoDone
		inc a
		jr GoDoneY
GoLeft:
	push af
		ld a,(etch_x)
		or a
		jr z,GoDone
		dec a
GoDoneX:
		ld (etch_x),a
		jr goDone
GoRight:
	push af
		ld a,(etch_x)
		cp 95
		jr z,GoDone
		inc a
		jr GoDoneX

InfoTxt2:
	.db "Kerm Martian 2010",0
.end
END					;fin

